diff -r 411de35de7fc -r 78219b10be7c libinterp/corefcn/stack-frame.cc
--- a/libinterp/corefcn/stack-frame.cc	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/corefcn/stack-frame.cc	Mon Jan 22 23:38:08 2024 +0100
@@ -2507,6 +2487,26 @@
 
 #endif
 
+  void visit_bytecode_script_stack_frame (bytecode_script_stack_frame& frame)
+  {
+    clean_frame (frame);
+
+    std::shared_ptr<stack_frame> alink = frame.access_link ();
+
+    if (alink)
+      alink->accept (*this);
+  }
+
+  void visit_bytecode_nested_fcn_stack_frame (bytecode_nested_fcn_stack_frame& frame)
+  {
+    clean_frame (frame);
+
+    std::shared_ptr<stack_frame> alink = frame.access_link ();
+
+    if (alink)
+      alink->accept (*this);
+  }
+
 private:
 
   void maybe_clear_symbol (stack_frame& frame, const symbol_record& sym)
@@ -2751,9 +2751,7 @@
 
   void visit_bytecode_fcn_stack_frame (bytecode_fcn_stack_frame& frame)
   {
-    // For scripts, only collect symbol info in the outer most frame
-    if (!frame.is_script_frame ())
-      append_list (frame);
+    append_list (frame);
 
     std::shared_ptr<stack_frame> alink = frame.access_link ();
 
@@ -2763,6 +2761,25 @@
 
 #endif
 
+  void visit_bytecode_script_stack_frame (bytecode_script_stack_frame& frame)
+  {
+    // For scripts, only collect symbol info in the outer most frame
+    std::shared_ptr<stack_frame> alink = frame.access_link ();
+
+    if (alink)
+      alink->accept (*this);
+  }
+
+  void visit_bytecode_nested_fcn_stack_frame (bytecode_nested_fcn_stack_frame& frame)
+  {
+    append_list (frame);
+
+    std::shared_ptr<stack_frame> alink = frame.access_link ();
+
+    if (alink)
+      alink->accept (*this);
+  }
+
 private:
 
   typedef std::pair<std::string, symbol_info_list> syminf_list_elt;
@@ -2932,7 +2949,7 @@
 
 #if defined (OCTAVE_ENABLE_BYTECODE_EVALUATOR)
 
-std::shared_ptr<stack_frame> stack_frame::create_bytecode (
+std::shared_ptr<stack_frame> stack_frame::create_bytecode_script (
                    tree_evaluator& tw,
                    octave_user_script *fcn,
                    vm &vm,
@@ -2941,7 +2958,15 @@
                    const std::shared_ptr<stack_frame>& static_link,
                    int nargout, int nargin)
 {
-  auto frame = create_bytecode (tw, static_cast<octave_user_code*> (fcn), vm, index, parent_link, static_link, nargout, nargin);
+  bytecode_script_stack_frame *new_frame_raw
+    = new bytecode_script_stack_frame (tw, fcn, index, parent_link, static_link,
+                                       vm, nargout, nargin);
+  std::shared_ptr<stack_frame> frame (new_frame_raw);
+
+  // The bytecode stackframe needs to know if it needs to save away
+  // all the stack variables. So it need to keep track of if it is saved
+  // somewhere outsite the VM
+  new_frame_raw->m_weak_ptr_to_self = frame;
 
   std::shared_ptr<stack_frame> eval_frame = static_link;
 
@@ -2966,7 +2991,7 @@
   return frame;
 }
 
-std::shared_ptr<stack_frame> stack_frame::create_bytecode (
+std::shared_ptr<stack_frame> stack_frame::create_bytecode_nested (
                    tree_evaluator& tw,
                    octave_user_code *fcn,
                    vm &vm,
@@ -2976,12 +3001,37 @@
                    const std::shared_ptr<stack_frame>& access_link,
                    int nargout, int nargin)
 {
-  auto frame = create_bytecode (tw, fcn, vm, index, parent_link, static_link, nargout, nargin);
-  frame->m_access_link = access_link;
+  bytecode_nested_fcn_stack_frame *new_frame_raw
+    = new bytecode_nested_fcn_stack_frame (tw, fcn, index, parent_link, static_link, access_link,
+                                        vm, nargout, nargin);
+  std::shared_ptr<stack_frame> frame (new_frame_raw);
+
+  CHECK_PANIC (frame->m_access_link); // Should always be set
+
+  // The bytecode stackframe needs to know if it needs to save away
+  // all the stack variables. So it need to keep track of if it is saved
+  // somewhere outsite the VM
+  new_frame_raw->m_weak_ptr_to_self = frame;
 
   return frame;
 }
 
+std::shared_ptr<stack_frame> stack_frame::create_bytecode_anon (
+                   tree_evaluator& tw,
+                   octave_user_code *fcn,
+                   vm &vm,
+                   std::size_t index,
+                   const std::shared_ptr<stack_frame>& parent_link,
+                   const std::shared_ptr<stack_frame>& static_link,
+                   const std::shared_ptr<stack_frame>& access_link,
+                   int nargout, int nargin)
+{
+  auto new_frame = create_bytecode (tw, fcn, vm, index, parent_link, static_link, nargout, nargin);
+  new_frame->m_access_link = access_link;
+
+  return new_frame;
+}
+
 std::shared_ptr<stack_frame> stack_frame::create_bytecode (
                    tree_evaluator& tw,
                    octave_user_code *fcn,
@@ -3010,19 +3060,7 @@
       // somewhere outsite the VM
       p->m_weak_ptr_to_self = new_frame;
 
-      // For nested frames we need to set the access link to the root function
-      if (fcn->is_nested_function ())
-        {
-          // If the parent have an access link, that should be the root function.
-          // E.g. if the current frame we are pushing is a nested nested frame.
-          //
-          // Otherwise, the parent_link is the root frame.
-          //
-          if (parent_link->m_access_link)
-            new_frame->m_access_link = parent_link->m_access_link;
-          else
-            new_frame->m_access_link = parent_link;
-        }
+      CHECK_PANIC(!fcn->is_nested_function ());
 
       return new_frame;
     }
@@ -3038,19 +3076,7 @@
       // somewhere outsite the VM
       new_frame_raw->m_weak_ptr_to_self = new_frame;
 
-      // For nested frames we need to set the access link to the root function
-      if (fcn->is_nested_function ())
-        {
-          // If the parent have an access link, that should be the root function.
-          // E.g. if the current frame we are pushing is a nested nested frame.
-          //
-          // Otherwise, the parent_link is the root frame.
-          //
-          if (parent_link->m_access_link)
-            new_frame->m_access_link = parent_link->m_access_link;
-          else
-            new_frame->m_access_link = parent_link;
-        }
+      CHECK_PANIC(!fcn->is_nested_function ());
 
       return new_frame;
     }
diff -r 411de35de7fc -r 78219b10be7c libinterp/corefcn/stack-frame.h
--- a/libinterp/corefcn/stack-frame.h	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/corefcn/stack-frame.h	Mon Jan 22 23:38:08 2024 +0100
@@ -199,23 +199,34 @@
                    int nargout, int nargin);
 
   static std::shared_ptr<stack_frame>
-  create_bytecode (tree_evaluator& tw,
-                   octave_user_code *fcn,
-                   vm &vm,
-                   std::size_t index,
-                   const std::shared_ptr<stack_frame>& parent_link,
-                   const std::shared_ptr<stack_frame>& static_link,
-                   const std::shared_ptr<stack_frame>& access_link,
-                   int nargout, int nargin);
+  create_bytecode_nested (tree_evaluator& tw,
+                          octave_user_code *fcn,
+                          vm &vm,
+                          std::size_t index,
+                          const std::shared_ptr<stack_frame>& parent_link,
+                          const std::shared_ptr<stack_frame>& static_link,
+                          const std::shared_ptr<stack_frame>& access_link,
+                          int nargout, int nargin);
 
   static std::shared_ptr<stack_frame>
-  create_bytecode (tree_evaluator& tw,
-                   octave_user_script *fcn,
-                   vm &vm,
-                   std::size_t index,
-                   const std::shared_ptr<stack_frame>& parent_link,
-                   const std::shared_ptr<stack_frame>& static_link,
-                   int nargout, int nargin);
+  create_bytecode_anon (tree_evaluator& tw,
+                        octave_user_code *fcn,
+                        vm &vm,
+                        std::size_t index,
+                        const std::shared_ptr<stack_frame>& parent_link,
+                        const std::shared_ptr<stack_frame>& static_link,
+                        const std::shared_ptr<stack_frame>& access_link,
+                        int nargout, int nargin);
+
+  static std::shared_ptr<stack_frame>
+  create_bytecode_script (tree_evaluator& tw,
+                          octave_user_script *fcn,
+                          vm &vm,
+                          std::size_t index,
+                          const std::shared_ptr<stack_frame>& parent_link,
+                          const std::shared_ptr<stack_frame>& static_link,
+                          int nargout, int nargin);
+
 #endif
 
   stack_frame (const stack_frame& elt) = default;
@@ -646,11 +657,10 @@
   // The VM needs to tell the bytecode stackframe that it unwinds so
   // that it can check whether to save the stack.
   virtual void vm_unwinds () {}
-  virtual void vm_dbg_check_scope () {}
   virtual void vm_clear_for_cache () {}
-  virtual void vm_enter_script () {}
-  virtual void vm_exit_script () {}
-  virtual void vm_enter_nested () {}
+  virtual void vm_enter_script () { panic_impossible (); }
+  virtual void vm_exit_script () { panic_impossible (); }
+  virtual void vm_enter_nested () { panic_impossible (); }
 
 #endif
 
diff -r 411de35de7fc -r 78219b10be7c libinterp/octave-value/ov-base.h
--- a/libinterp/octave-value/ov-base.h	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/octave-value/ov-base.h	Mon Jan 22 23:38:08 2024 +0100
@@ -834,6 +834,7 @@
     OCT_CALL,
     OCT_HANDLE,
     OCT_OBJECT,
+    OCT_NESTED_HANDLE,
   };
 
   virtual vm_call_dispatch_type vm_dispatch_call ();
diff -r 411de35de7fc -r 78219b10be7c libinterp/octave-value/ov-fcn-handle.cc
--- a/libinterp/octave-value/ov-fcn-handle.cc	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/octave-value/ov-fcn-handle.cc	Mon Jan 22 23:38:08 2024 +0100
@@ -402,6 +402,17 @@
   void print_raw (std::ostream&, bool pr_as_read_syntax,
                   int current_print_indent_level) const;
 
+#if defined (OCTAVE_ENABLE_BYTECODE_EVALUATOR)
+  octave_function *
+  get_cached_fcn (void *, void *) { return m_fcn.function_value (); }
+
+  octave_function *
+  get_cached_fcn (const octave_value_list&) { return m_fcn.function_value (); }
+
+  bool
+  has_function_cache () const { return true; }
+#endif
+
 protected:
 
   // The function we are handling.
@@ -471,6 +482,11 @@
     return m_stack_context;
   }
 
+#if defined (OCTAVE_ENABLE_BYTECODE_EVALUATOR)
+  std::shared_ptr<octave::stack_frame>
+  get_closure_frame () { return m_stack_context; }
+#endif
+
 protected:
 
   // Pointer to closure stack frames.
@@ -503,6 +519,11 @@
   friend bool is_equal_to (const weak_nested_fcn_handle& fh1,
                            const weak_nested_fcn_handle& fh2);
 
+#if defined (OCTAVE_ENABLE_BYTECODE_EVALUATOR)
+  std::shared_ptr<octave::stack_frame>
+  get_closure_frame () { return m_stack_context.lock (); }
+#endif
+
 protected:
 
   // Pointer to closure stack frames.
@@ -784,6 +805,9 @@
 #if defined (OCTAVE_ENABLE_BYTECODE_EVALUATOR)
   // Compile the underlying function to bytecode for the VM.
   void compile ();
+
+  std::shared_ptr<octave::stack_frame>
+  get_closure_frame () { return m_stack_context; }
 #endif
 
 protected:
@@ -820,6 +844,11 @@
   friend bool is_equal_to (const weak_anonymous_fcn_handle& fh1,
                            const weak_anonymous_fcn_handle& fh2);
 
+#if defined (OCTAVE_ENABLE_BYTECODE_EVALUATOR)
+  std::shared_ptr<octave::stack_frame>
+  get_closure_frame () { return m_stack_context.lock (); }
+#endif
+
 protected:
 
   // Pointer to closure stack frames.
diff -r 411de35de7fc -r 78219b10be7c libinterp/octave-value/ov-fcn-handle.h
--- a/libinterp/octave-value/ov-fcn-handle.h	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/octave-value/ov-fcn-handle.h	Mon Jan 22 23:38:08 2024 +0100
@@ -165,6 +165,10 @@
 
   virtual void compile () { }
 
+#if defined (OCTAVE_ENABLE_BYTECODE_EVALUATOR)
+  virtual std::shared_ptr<octave::stack_frame> get_closure_frame () { return nullptr; }
+#endif
+
 protected:
 
   void warn_load (const char *file_type) const;
@@ -387,6 +391,8 @@
 
   vm_call_dispatch_type vm_dispatch_call ()
   {
+    if (m_rep->is_nested () || m_rep->is_anonymous ())
+      return vm_call_dispatch_type::OCT_NESTED_HANDLE;
     if (m_rep->has_function_cache ())
       return vm_call_dispatch_type::OCT_CALL;
 
@@ -395,6 +401,9 @@
 
   void compile () { m_rep->compile (); }
 
+  std::shared_ptr<octave::stack_frame>
+  get_closure_frame () { return m_rep->get_closure_frame (); }
+
 #endif
 
 private:
diff -r 411de35de7fc -r 78219b10be7c libinterp/octave-value/ov-ref.cc
--- a/libinterp/octave-value/ov-ref.cc	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/octave-value/ov-ref.cc	Mon Jan 22 23:38:08 2024 +0100
@@ -135,34 +135,34 @@
 octave_value &
 octave_value_ref_vmlocal::ref ()
 {
-  return m_frame->varref (m_sym);
+  return m_frame->varref (m_sym.data_offset ());
 }
 
 octave_value
 octave_value_ref_vmlocal::deref ()
 {
-  return m_frame->varval (m_sym);
+  return m_frame->varval (m_sym.data_offset ());
 }
 
 void
 octave_value_ref_vmlocal::set_value (octave_value val)
 {
-  m_frame->varref (m_sym) = val;
+  m_frame->varref (m_sym.data_offset ()) = val;
 }
 
 octave::stack_frame::scope_flags
 octave_value_ref_vmlocal::get_scope_flag ()
 {
-  return m_frame->scope_flag (m_sym);
+  return m_frame->get_scope_flag (m_sym.data_offset ());
 }
 
 void
 octave_value_ref_vmlocal::mark_globalness_in_owning_frame (bool should_be_global)
 {
   if (should_be_global)
-    m_frame->mark_global (m_sym);
+    m_frame->set_scope_flag (m_sym.data_offset (), octave::stack_frame::scope_flags::GLOBAL);
   else
-    m_frame->unmark_global (m_sym);
+    m_frame->set_scope_flag (m_sym.data_offset (), octave::stack_frame::scope_flags::LOCAL);
 }
 
 octave_value &
diff -r 411de35de7fc -r 78219b10be7c libinterp/octave-value/ov.h
--- a/libinterp/octave-value/ov.h	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/octave-value/ov.h	Mon Jan 22 23:38:08 2024 +0100
@@ -54,6 +54,10 @@
 #if defined (OCTAVE_ENABLE_BYTECODE_EVALUATOR)
 class vm;
 class bytecode_fcn_stack_frame;
+class bytecode_script_stack_frame;
+class bytecode_nested_fcn_stack_frame;
+class bytecode_anon_fcn_stack_frame;
+class bytecode_frame;
 #endif
 
 OCTAVE_END_NAMESPACE(octave)
@@ -1551,6 +1555,9 @@
   friend class octave_value_vm;
   friend class octave::vm;
   friend class octave::bytecode_fcn_stack_frame;
+  friend class octave::bytecode_script_stack_frame;
+  friend class octave::bytecode_nested_fcn_stack_frame;
+  friend class octave::bytecode_frame;
   friend class octave::scope_stack_frame;
   friend class octave::base_value_stack_frame;
   friend class octave_value_ref_ptr;
diff -r 411de35de7fc -r 78219b10be7c libinterp/parse-tree/pt-bytecode-vm.cc
--- a/libinterp/parse-tree/pt-bytecode-vm.cc	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/parse-tree/pt-bytecode-vm.cc	Mon Jan 22 23:38:08 2024 +0100
@@ -1570,7 +1570,8 @@
     // If the pointer is not shared, stash it in a cache which is used
     // to avoid having to allocate shared pointers each frame push.
     // If it is a closure context, there might be weak pointers to it from function handles.
-    if (fp.unique () && m_frame_ptr_cache.size () < 8 && !fp->is_closure_context ())
+    if (fp.unique () && m_frame_ptr_cache.size () < 8 && !fp->is_closure_context () 
+        && fp->is_user_fcn_frame ())
       {
         fp->vm_clear_for_cache ();
         m_frame_ptr_cache.push_back (std::move (fp));
@@ -2628,6 +2629,15 @@
               }
           }
         break;
+
+        case octave_base_value::vm_call_dispatch_type::OCT_NESTED_HANDLE:
+          {
+            (*sp++).i = n_args_on_stack;
+            (*sp++).i = nargout;
+            (*sp++).i = nargout; // "caller_nvalback". Caller wants as many values returned as it wants the callee to produce
+            (*sp++).i = slot;
+            goto make_nested_handle_call;
+          }
       }
   }
   DISPATCH ();
@@ -4288,6 +4298,7 @@
           break;
 
         case octave_base_value::vm_call_dispatch_type::OCT_SUBSREF:
+        case octave_base_value::vm_call_dispatch_type::OCT_NESTED_HANDLE:
           PANIC ("Invalid dispatch");
       }
   }
@@ -4713,6 +4724,16 @@
 
               }
           }
+          break;
+
+        case octave_base_value::vm_call_dispatch_type::OCT_NESTED_HANDLE:
+          {
+            (*sp++).i = n_args_on_stack;
+            (*sp++).i = nargout;
+            (*sp++).i = nargout; // "caller_nvalback". Caller wants as many values returned as it wants the callee to produce
+            (*sp++).i = slot;
+            goto make_nested_handle_call;
+          }
       }
   }
   DISPATCH ();
@@ -4894,6 +4915,243 @@
   }
   DISPATCH ();
 
+// Not an opcode. Some opcodes jump here to handle nested handle function calls
+make_nested_handle_call:
+{
+  // Restore values from the stack
+  int slot = (*--sp).i;
+  int caller_nvalback = (*--sp).i;
+  int nargout = (*--sp).i;
+  int n_args_on_stack = (*--sp).i;
+
+  octave_value &ov = (sp[-1 - n_args_on_stack]).ov;
+
+  octave_function *fcn;
+  try
+    {
+      stack_element *first_arg = &sp[-n_args_on_stack];
+      stack_element *end_arg = &sp[0];
+      fcn = ov.get_cached_fcn (first_arg, end_arg);
+    }
+  CATCH_EXECUTION_EXCEPTION
+
+  if (! fcn)
+    {
+      (*sp++).ps = new std::string {name_data[slot]};
+      (*sp++).i = static_cast<int> (error_type::ID_UNDEFINED);
+      goto unwind;
+    }
+
+  if (fcn->is_compiled ())
+    {
+      octave_user_code *usr_fcn = static_cast<octave_user_code *> (fcn);
+
+      // The code bellow is like MAKE_BYTECODE_CALL, but with support for setting an access frame from the handle
+      if (sp + stack_min_for_new_call >= m_stack + stack_size)
+        {
+          (*sp++).pee = new execution_exception {"error","","VM is running out of stack space"};
+          (*sp++).i = static_cast<int> (error_type::EXECUTION_EXC);
+          goto unwind;
+        }
+      /* We are now going to call another function */
+      /* compiled to bytecode */
+
+      m_tw->set_active_bytecode_ip (ip - code);
+      stack_element *first_arg = sp - n_args_on_stack;
+
+      /* Push address to first arg (or would one would have been */
+      /* if there are no args), so we can restore the sp at return */
+      (*sp++).pse = first_arg;
+
+      /* Push unwind data */
+      (*sp++).pud = unwind_data;
+
+      /* Push code */
+      (*sp++).puc = code;
+
+      /* Push data */
+      (*sp++).pov = data;
+
+      /* Push id names */
+      (*sp++).ps = name_data;
+
+      /* Push bsp */
+      (*sp++).pse = bsp;
+
+      /* Push the instruction pointer */
+      (*sp++).puc = ip;
+
+      /* The amount of return values the caller actually wants. Not necesserely the */
+      /* same as the amount of return values the caller wants the callee to produce. */
+      /* (last on caller stack) */
+      (*sp++).u = caller_nvalback;
+
+      /* set callee bsp */
+      m_sp = bsp = sp;
+
+      /* Push nargout (first on callee stack) */
+      (*sp++).u = nargout;
+
+      /* Set the new data, code etc */
+      bytecode &bc = usr_fcn->get_bytecode ();
+      if (OCTAVE_UNLIKELY (m_profiler_enabled))
+        {
+          auto p = vm::m_vm_profiler;
+          if (p)
+            {
+              std::string caller_name = data[2].string_value (); /* profiler_name () querried at compile time */
+              p->enter_fn (caller_name, bc);
+            }
+        }
+      m_data = data = bc.m_data.data ();
+      m_code = code = bc.m_code.data ();
+      m_name_data = name_data = bc.m_ids.data ();
+      m_unwind_data = unwind_data = &bc.m_unwind_data;
+
+
+      /* Set the ip to 0 */
+      ip = code;
+      int n_returns_callee = static_cast<signed char> (*ip++); /* Negative for varargout */
+      if (OCTAVE_UNLIKELY (n_returns_callee < 0))
+        {
+          if (n_returns_callee == -128) /* Anonymous function */
+            n_returns_callee = 1;
+          else
+            n_returns_callee = -n_returns_callee;
+        }
+      int n_args_callee = static_cast<signed char> (*ip++); /* Negative for varargin */
+      int n_locals_callee = POP_CODE_USHORT ();
+
+      if (n_args_callee < 0)
+      {
+        sp[0].pv = static_cast<void*> (usr_fcn);
+        goto varargin_call;
+      }
+
+      /* Construct return values - note nargout */
+      /* is allready pushed as a uint64 */
+      for (int ii = 1; ii < n_returns_callee; ii++)
+        PUSH_OV ();
+
+      int n_args_on_callee_stack = 0;
+      bool all_too_many_args = false;
+      /* Move the args to the new stack */
+      for (int ii = 0; ii < n_args_on_stack; ii++)
+        {
+          octave_value &arg = first_arg[ii].ov;
+
+          if (arg.is_cs_list ())
+            {
+              octave_value_list args = arg.list_value ();
+              octave_idx_type n_el = args.length ();
+              if (n_el + n_args_on_callee_stack > 512)
+                {
+                  all_too_many_args = true;
+                }
+              else
+                {
+                  for (int j = 0; j < n_el; j++)
+                    {
+                      PUSH_OV (args (j));
+                      n_args_on_callee_stack++;
+                    }
+                }
+            }
+          else
+            {
+              PUSH_OV (std::move (arg));
+              n_args_on_callee_stack++;
+            }
+          /* Destroy the args */
+          arg.~octave_value ();
+        }
+      /* Construct missing args */
+      for (int ii = n_args_on_callee_stack; ii < n_args_callee; ii++)
+        PUSH_OV ();
+
+      /* Construct locals */
+      int n_locals_to_ctor =
+        n_locals_callee - n_args_callee - n_returns_callee;
+      for (int ii = 0; ii < n_locals_to_ctor; ii++)
+        PUSH_OV ();
+
+      try
+        {
+          octave_fcn_handle *h = ov.fcn_handle_value();
+          CHECK_PANIC (h);
+          CHECK_PANIC (h->is_nested () || h->is_anonymous ());
+          auto closure_frame = h->get_closure_frame ();
+
+          m_tw->push_stack_frame(*this, usr_fcn, nargout, n_args_on_callee_stack, closure_frame);
+        }
+      CATCH_STACKPUSH_EXECUTION_EXCEPTION /* Sets m_could_not_push_frame to true */
+      CATCH_STACKPUSH_BAD_ALLOC
+
+      if (OCTAVE_UNLIKELY (m_output_ignore_data))
+        {
+          /* Called fn needs to know about ignored outputs .e.g. [~, a] = foo() */
+          m_output_ignore_data->push_frame (*this);
+        }
+
+      /* "auto var" in the frame object. This is needed if nargout() etc are called */
+      set_nargout (nargout);
+
+      if (all_too_many_args)
+        {
+          std::string fn_name = unwind_data->m_name;
+          (*sp++).pee = new execution_exception {"error", "Octave:invalid-fun-call",
+                                                fn_name + ": function called with over 512 inputs."
+                                                " Consider using varargin."};
+          (*sp++).i = static_cast<int> (error_type::EXECUTION_EXC);
+          goto unwind;
+        }
+      if (n_args_on_callee_stack > n_args_callee)
+        {
+          std::string fn_name = unwind_data->m_name;
+          (*sp++).pee = new execution_exception {"error", "Octave:invalid-fun-call",
+                                                fn_name + ": function called with too many inputs"};
+          (*sp++).i = static_cast<int> (error_type::EXECUTION_EXC);
+          goto unwind;
+        }
+      /* N_RETURNS is negative for varargout */
+      int n_returns = N_RETURNS () - 1; /* %nargout in N_RETURNS */
+      if (n_returns >= 0 && nargout > n_returns)
+        {
+          std::string fn_name = unwind_data->m_name;
+          (*sp++).pee = new execution_exception {"error", "Octave:invalid-fun-call",
+                                                fn_name + ": function called with too many outputs"};
+          (*sp++).i = static_cast<int> (error_type::EXECUTION_EXC);
+          goto unwind;
+        }
+
+      // Now dispatch to first instruction in the
+      // called function
+    }
+  else
+    {
+      // Make an ovl with the args
+      octave_value_list ovl;
+      // The operands are on the top of the stack
+      POP_STACK_RANGE_TO_OVL (ovl, sp - n_args_on_stack, sp);
+
+      try
+        {
+          m_tw->set_active_bytecode_ip (ip - code);
+          octave_value_list ret = ov.simple_subsref ('(', ovl, nargout);
+          ovl.clear ();
+
+          STACK_DESTROY (1);
+          EXPAND_CSLIST_PUSH_N_OVL_ELEMENTS_TO_STACK (ret, nargout);
+        }
+      CATCH_INTERRUPT_EXCEPTION
+      CATCH_INDEX_EXCEPTION_WITH_MAYBE_NAME(slot != 0)
+      CATCH_EXECUTION_EXCEPTION
+      CATCH_BAD_ALLOC
+      CATCH_EXIT_EXCEPTION
+    }
+}
+DISPATCH ();
+
 unwind:
   {
     ip--; // Rewind ip to after the opcode (i.e. arg0's position in the code)
@@ -5000,7 +5258,8 @@
         if (!m_could_not_push_frame)
           {
             auto sf = m_tw->get_current_stack_frame ();
-            sf->vm_exit_script (); // Just returns for non-scripts
+            if (sf->is_user_script_frame ())
+              sf->vm_exit_script ();
             sf->vm_unwinds ();
           }
 
@@ -5765,6 +6024,8 @@
 
     switch (ov.vm_dispatch_call ())
       {
+        case octave_base_value::vm_call_dispatch_type::OCT_NESTED_HANDLE:
+          PANIC ("Invalid dispatch");
         case octave_base_value::vm_call_dispatch_type::OCT_SUBSREF:
           {
             // TODO: subsref should take ovl instead and be chained,
@@ -6755,6 +7016,24 @@
           {
             switch (ov.vm_dispatch_call ())
               {
+                case octave_base_value::vm_call_dispatch_type::OCT_NESTED_HANDLE:
+                  {
+                    // The last iteration the caller wants as many returned on the stack
+                    // as it wants the callee to produce.
+                    // In any other iteration the caller wants one value returned, but still
+                    // wants the callee to produce nargout number of return values.
+                    int caller_nvalback;
+                    if (i + 1 != n)
+                      caller_nvalback = 1;
+                    else
+                      caller_nvalback = nargout;
+                    
+                    (*sp++).i = n_args_on_stack;
+                    (*sp++).i = nargout;
+                    (*sp++).i = caller_nvalback;
+                    (*sp++).i = 0;
+                    goto make_nested_handle_call;
+                  }
                 case octave_base_value::vm_call_dispatch_type::OCT_FN_LOOKUP:
                   {
                     (*sp++).pee = new execution_exception {"error", "", "invalid undefined value in chained index expression"}; // TODO: Uninformative?
@@ -6958,8 +7237,9 @@
 
                 switch (ov.vm_dispatch_call ())
                   {
+                    case octave_base_value::vm_call_dispatch_type::OCT_NESTED_HANDLE:
                     case octave_base_value::vm_call_dispatch_type::OCT_FN_LOOKUP:
-                      panic_impossible ();
+                      PANIC ("Invalid dispatch");
                       break;
                     case octave_base_value::vm_call_dispatch_type::OCT_SUBSREF:
                       {
@@ -8254,7 +8534,10 @@
       try
         {
           if (fn->is_anonymous_function ())
-            octave::compile_anon_user_function (*fn, false, *locals);
+            {
+              CHECK_PANIC (locals);
+              octave::compile_anon_user_function (*fn, false, *locals);
+            }
           else
             octave::compile_user_function (*fn, false);
 
diff -r 411de35de7fc -r 78219b10be7c libinterp/parse-tree/pt-bytecode-walk.cc
--- a/libinterp/parse-tree/pt-bytecode-walk.cc	Mon Jan 22 11:27:42 2024 +0100
+++ b/libinterp/parse-tree/pt-bytecode-walk.cc	Mon Jan 22 23:38:08 2024 +0100
@@ -75,6 +75,14 @@
       bw.m_anon_local_values = &locals;
       bw.m_is_anon = true; // Flag used during compilation
 
+      // We need to insert all the locals into the scope object. The tree_evaluator
+      // does this as part of pushing the frame object, but just do it here once instead.
+      auto scope = ufn.scope ();
+      for (auto it : locals)
+        {
+          scope.insert (it.first);
+        }
+
       ufn.accept (bw);
 
       if (do_print)
@@ -2871,28 +2879,26 @@
       // of frame offset by checking the size is one.
       CHECK (m_code.m_unwind_data.m_external_frame_offset_to_internal.size () == 1);
 
+      auto scope = fcn.scope ();
+
       for (auto kv : *m_anon_local_values)
         {
           std::string name = kv.first;
 
-          // Nested anonymous functions leads to local variables that need to be stored
-          // in all outer anonymous function scopes. I.e. the local is in m_anon_local_values
-          // but not in m_map_locals_to_slot.
-          //
-          // These variables are given "fake" frame offset and data offset so they are accessable.
-          // They are fake in as much, that the scope object does not have the offsets registered
-          // and they are only lookup-able by name. But the resulting symbol_record (with the fake offsets)
-          // is usable. E.g. tree_evaluator::evaluate_anon_fcn_handle() needs this.
+          // Add slots for the locals provided by the scope of the anonymous function
           if (m_map_locals_to_slot.find (name) == m_map_locals_to_slot.end ())
             {
               int slot_added = add_id_to_table (name);
 
-              // Fake frame offset of one
-              m_code.m_unwind_data.m_external_frame_offset_to_internal.resize (2);
+              auto sym = scope.find_symbol (name);
+
+              CHECK_PANIC (sym.is_valid ());
+              CHECK_PANIC (sym.frame_offset () == 0);
+
               // Increasing number for fake external offset
-              int fake_external_offset = m_code.m_unwind_data.m_external_frame_offset_to_internal[1].size ();
-              m_code.m_unwind_data.m_external_frame_offset_to_internal[1][fake_external_offset] = slot_added;
-
+              int external_offset = sym.data_offset ();
+
+              m_code.m_unwind_data.m_external_frame_offset_to_internal[0][external_offset] = slot_added;
               m_code.m_unwind_data.m_map_user_locals_names_to_slot.insert ({name, slot_added});
             }
 
